#!/usr/bin/perl

# nessimp-v0.05.pl by Randy Nash (nashr@atriskonline.com)
# Copyright (C) 2002-2005 Randy Nash - @RISK Online (www.atriskonline.com)
#
# nessimp is part of the nessQuick package which can be downloaded at
# http://www.atriskonline.com/projects/nessQuick.shtml
#
# nessimp: Imports Nessus .nbe data into a MySQL database
#
# --- GNU General Public License Disclamer ---
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
use strict;
use DBI;

# Name of import file
#
print "Enter full .nbe filename: ";
my $infile = <STDIN>;
chomp $infile;

# Connect To Database
#
my $database = "nessquick";
my $hostname = "localhost";
my $username = "root";
my $password = "";
my $dbh = DBI->connect("DBI:mysql:$database:$hostname", $username, $password);
die "Cannot log into database.  Please try again later.\n" unless $dbh;
print "Connected to $database... \n";


# Open file for input
#
open(INPUT,"<$infile")||die("Can't open .NBE file");
print "Opened $infile... \n";

# Nessus classifies vulnerabilities into:
# 3. Security Holes
# the attack was a success and poses a great security risk**
# 2. Security Warnings
# the attack was a success but is not a great security problem
# 1. Security Notes
# information found about your system through scans/banners**
# 0. Informational

# Risk Values
my %RISK_VALUES =
  ("" => 0,
   "Security Note" => 1,
   "Security Warning" => 2,
   "Security Hole" => 3
  );

# Initialize counter
my $loopcnt = 1;

# loop through input file and insert into table
#
print "Processing input file... \n";
while (<INPUT>)
{

# print and increment counter
  print "$loopcnt\r";
  $loopcnt++;

# Initialize field values each time to ensure the are clear
#
  my $infield1  = " ";   # record type
  my $infield2  = " ";   # domain
  my $infield3  = " ";   # host
  my $infield4  = " ";   # service
  my $infield5  = " ";   # scriptid
  my $infield6  = " ";   # risk
  my $remainder = " ";  # msg
  my $risknum   = 0;

  ($infield1,$infield2,$infield3,$infield4,$infield5,$infield6,$remainder)=split(/\|/,$_,7);

# Insert values into appropriate table
#
	if ($infield1 eq "results") {
    # Assigning Risk Values from Nessus
    $risknum = $RISK_VALUES{$infield6};
    # Cleanup of message/description field
    $remainder =~ s/;/\n/g;
  	$remainder =~ s/\'/\\\'/g;
   	$dbh->do("insert into results (domain, host, service, scriptid, riskval, msg)
   	          values ('$infield2','$infield3','$infield4','$infield5','$risknum',\'$remainder\')
 		");
 	}
	else {
 		$dbh->do("insert into timestamps (unused, host, progress, timestamp)
           		values ('$infield2','$infield3','$infield4',\'$infield5\')
 		");
 	}
}

print "\nFinished processing input file... \n";

close INPUT;
$dbh->disconnect;
exit(0); 

