#!/usr/bin/perl

# nessrpt2-v0.05.pl by Randy Nash (nashr@atriskonline.com)
# Copyright (C) 2002-2005 Randy Nash - @RISK Online (www.atriskonline.com)
#
# nessrpt2 is part of the nessQuick package which can be downloaded at
# http://www.atriskonline.com/projects/nessQuick.shtml
#
# nessrpt2: Generates a report from Nessus .nbe data:
#   List of all Hosts that were scanned
#
# --- GNU General Public License Disclamer ---
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
use strict;
# use warnings;
# use diagnostics;

use DBI;

# Connect To Database
#
my $database = "nessquick";
my $hostname = "localhost";
my $username = "root";
my $password = "";
my $dbh = DBI->connect("DBI:mysql:$database:$hostname", $username, $password);
die "Cannot log into database.  Please try again later.\n" unless $dbh;

# This section on hold for now...
# Name of report file
#
#print "Enter desired report filename: ";
#$outfile = <STDIN>;
#chomp $outfile;
#
#open the output file 
#open(REPORT, ">$outfile") || die("Couldn't open report file"); 

# Risk Values
my %RISK_VALUES =
  (0 => "Informational Notes",
   1 => "Security Notes",
   2 => "Security Warnings",
   3 => "Security Holes"
  );

##################################################
# Report 2: List of all Hosts that were scanned
#
my $sth2 = $dbh->prepare("SELECT host
                          FROM results
                          GROUP BY host")
	or die "Can't prepare: $dbh->errstr\n";

# Execute query
#
my $rv2 = $sth2->execute
	or die "can't execute the query: $sth2->errstr";

# "while" loop to produce report
#
print "\nNessus scanned the following hosts:\n\n";

while (my @array2 = $sth2->fetchrow_array)
	{
    (my $host) = @array2;
    print "\t$host\n";
  }
print "\f";

$dbh->disconnect;

exit(0); 

