#!/usr/bin/perl

# nessrpt4-v0.05.pl by Randy Nash (nashr@atriskonline.com)
# Copyright (C) 2002-2005 Randy Nash - @RISK Online (www.atriskonline.com)
#
# nessrpt4 is part of the nessQuick package which can be downloaded at
# http://www.atriskonline.com/projects/nessQuick.shtml
#
# nessrpt4: Generates a report from Nessus .nbe data:
#   Risk Counts by IP
#
# --- GNU General Public License Disclamer ---
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
use strict;
# use warnings;
# use diagnostics;

use DBI;

# Connect To Database
#
my $database = "nessquick";
my $hostname = "localhost";
my $username = "root";
my $password = "";
my $dbh = DBI->connect("DBI:mysql:$database:$hostname", $username, $password);
die "Cannot log into database.  Please try again later.\n" unless $dbh;

# This section on hold for now...
# Name of report file
#
#print "Enter desired report filename: ";
#$outfile = <STDIN>;
#chomp $outfile;
#
#open the output file 
#open(REPORT, ">$outfile") || die("Couldn't open report file"); 

# Risk Values
my %RISK_VALUES =
  (0 => "Informational Notes",
   1 => "Security Notes",
   2 => "Security Warnings",
   3 => "Security Holes"
  );

##################################################
# Report 4: Risk Counts by IP
#
my $sth4 = $dbh->prepare("SELECT host, riskval, count(riskval)
                          FROM results
                          GROUP BY host, -(riskval)")
	or die "Can't prepare: $dbh->errstr\n";

# Execute query
#
my $rv4 = $sth4->execute
	or die "can't execute the query: $sth4->errstr";

print "\nCount of findings by IP/Host:\n\n";

my $first4 = "yes";
my $lasthost = " ";

# "while" loop to produce report
#
while (my @array4 = $sth4->fetchrow_array)
	{
    (my $host, my $riskval, my $count) = @array4;
    
      if ($host ne $lasthost)
        {
          if ($first4 eq "yes")
            {
              print "\n\t$host";
              $first4 = "no";
              $lasthost = $host;
            }
          else
            {
#              print "\t\t";
              $first4 = "yes";
              $lasthost = " ";
            }
        }
      else
        {
          print "\t\t";
          $first4 = "yes";
          $lasthost = $host;
        }
    my $risklevel = $RISK_VALUES{$riskval};
    print "\t$count\t$risklevel\n";
  }
print "\f";

$dbh->disconnect;

exit(0); 

